/*********************************************************/
/* This file is part of strs a statistical test suite    */
/*              of random sequences.                     */
/*             David Lubicz CELAR                        */
/*            Copyright (C) 2006 David Lubicz            */
/*********************************************************/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/***************************************************************/
/* Configuration of the test of random sequence                */
/***************************************************************/


#define ENGLISH
/* #define FRENCH */




#define DO_FREQUENCY
/*
#define DO_RUN
#define DO_MAURER
#define DO_ENTROPY
#define DO_CORRELATION
#define DO_SPECTRAL
#define DO_GAP
#define DO_COLLISION
#define DO_LINEAR_COMPLEXITY
*/

#define NB_CHUNKS 100
#define NBL_CHUNKS 500
#define NB_PARTS 6
#define NB_POINTS 200

#define MIN_FREQUENCY 1
#define MAX_FREQUENCY 16

#define MIN_ENTROPY 1
#define MAX_ENTROPY 16

#define MIN_CORRELATION 1
#define MAX_CORRELATION 16

#define MIN_SPECTRAL 1
#define MAX_SPECTRAL 4

#define MIN_RUN 4
#define MAX_RUN 16

#define MIN_GAP 4
#define MAX_GAP 16

#define MIN_MAURER 4
#define MAX_MAURER 8

#define SPACE 1

#define LOW_SAMPLE 5
#define MEMORY_CHUNK 1000000
#define MAX_MEMORY 50000000

#define GRAPH_DIR "graphics/"
#define EPS_DIR "eps/"
#define PLOT "plot_commands"
#define WITH_TITLE
#define TEX "output.tex"
#define MAX_LIGNES 30
#define MAX_COLUMNS 30

#ifdef ENGLISH
#define NAME_FREQUENCY "Frequency test"
#define NAME_CORRELATION "Correlation test"
#define NAME_SPECTRAL "Spectral test"
#define NAME_MAURER "Maurer tets"
#define NAME_RUN "Run test"
#define NAME_GAP "Gap test"
#define NAME_ENTROPY "Shannon entropy"
#define NAME_LINCOMP "Linear complexity"
#define NAME_COLLISION "Collision test"
#endif

#ifdef FRENCH
#define NAME_FREQUENCY "Test de frquence"
#define NAME_CORRELATION "Test de corrlation"
#define NAME_SPECTRAL "Test Spectral"
#define NAME_MAURER "Test de Maurer"
#define NAME_RUN "Suite de 1"
#define NAME_GAP "Suite de 0"
#define NAME_ENTROPY "Entropie de Shannon"
#define NAME_LINCOMP "Complexit lineaire"
#define NAME_COLLISION "Test de collision"
#endif

