/*********************************************************/
/* This file is part of strs a statistical test suite    */
/*              of random sequences.                     */
/*             David Lubicz CELAR                        */
/*            Copyright (C) 2006 David Lubicz            */
/*********************************************************/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**********************************************************/
/*        Definition of the prototype of functions        */
/*          of test.c                                     */
/**********************************************************/
#ifndef __STATISTIC_TEST_H__
#define __STATISTIC_TEST_H__
#include "../include/bitutils.h"
#include "statistic_types.h"

/* functions to output as a plotable data file a graph of a function */
extern int plot_graph(double *array, unsigned int nb_points, char *name);

/* functions to output as a plotable data file a graph of a function */
extern int plot_function(double (*F)(double,void *), void *parameter, double min, double max, unsigned int nb_points, char *name);

/* this function compute the chi_carre statistic for the observations the probabilities probabilities and for nliberty degree of liberty */
extern struct statistic Chi_Carre(bsize_t *, double *, bsize_t );

/* same as Chi_Carre calculated with an equiprobability for all the categories of observations */
extern struct statistic Equi_Chi_Carre(bsize_t *, bsize_t );
      
/* this function returns the value of the Kolmogorov-Smirnov test */
extern double Kolmogorov_Smirnov(double *, unsigned int, double (*)(double,void *), void *);
#endif /* __STATISTIC_TEST_H__*/
