/*********************************************************/
/* This file is part of strs a statistical test suite    */
/*              of random sequences.                     */
/*             David Lubicz CELAR                        */
/*            Copyright (C) 2006 David Lubicz            */
/*********************************************************/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/***************************************************************/
/* Types used in alea testing functions                        */
/***************************************************************/
#ifndef __STAT_TYPES_H_
#define __STAT_TYPES_H_

#include "../include/bitutils.h"
#include "../include/config.h"

struct node
{
  unsigned int next[2];
};

struct test_parameters
{
  struct BitField *data; /* data to test */
  bsize_t nb_chunks; /* number of chuncks */
  bsize_t length; /* length parameter of the test */
  bsize_t space; /* for correlation test purpose */ 
  char *file_name; /* file_name to output the result of the test */
  char *file_name1;
  word_t bit; /* for run or gap purpose */
  double min; /* range for the plot a theorical curve */
  double max; 
  int nb_points; /* number of ploted points on the theorical curve */
};

struct test
{
  double min; /* minimum value of the test on the sample */
  double max; /* maximum value of the test on the sample */
  double z;   /* result */
  int warning; /* little sample warning flag */
  int error; /* error flag */
  long int parameter; /* for spectral test purppose */
};

struct statistic
{
  double z; /* result */
  int warning; /* little sample warning flag */
  int error; /* error flag */
  unsigned long int result; /* result */
};

#endif /* __STAT_TYPE__ */
