#!/usr/bin/perl
@separator = ("%frequency%", "%correlation%", "%spectral%", "%maurer%", "%run%", "%gap%", "%entropy%","%berlekamp%","%collision%");
@gseparator = ("%frequencyg%", "%correlationg%", "%spectralg%", "%maurerg%", "%rung%", "%gapg%","%berlekampg%");
$template = "latex/template.tex";
$input = "output.tex";
$texout = "tmp/test.tex";
$eps ="eps";

@plot_cmd=("gnuplot", "plot_commands");
@cp_cmd=("cp", "eps/frequency1.eps", "tmp");
@cd_cmd=("cd","tmp");
@latex_cmd=("latex", "test.tex");
@dvi_cmd=("dvips","-o","test.ps","test.dvi");
@pdf_cmd=("ps2pdf", "test.ps");
@mv_cmd=("mv","test.pdf","..");

##############################################
#principal program
##############################################


open(TEMPLATE, "$template") or die "No such file or directory.";
open(OUTPUT, ">$texout");

while ($ligne = <TEMPLATE>)
{
#First insert the tables in the document#
    foreach $separator (@separator)
    {
	if ($ligne =~ m/$separator/)
	{
	    open(INPUT, "$input") or die "No such file or directory.";
	    $flag = 0;
	    while ($ligne1 = <INPUT>)
	    {

		if ($ligne1 =~ m/$separator/)
		{
		    $flag = ($flag == 0);
		}

		if ($flag == 1)
		{
		    print OUTPUT $ligne1;
		}
	    }   
	    close INPUT;
	    
	}
    }

#Then take care of the pictures#
    foreach $gseparator (@gseparator)
    {
	if ($ligne =~ m/$gseparator/)
	{
	    open(INPUT, "$input") or die "No such file or directory.";
	    $flag = 0;
	    while (($ligne1 = <INPUT>) && ($flag == 0))
	    {
		if ($ligne1 =~ m/$gseparator/)
		{
		    $min = <INPUT>;
		    $max = <INPUT>;
		    $min =~ s/%//g;
		    $max =~ s/%//g;
		    chop($min);
		    chop($max);
		    $flag = 1;
		}
	    }
	    close INPUT;

	    if ($flag == 1)
	    {
		$name = $gseparator;
		$name =~ s/%//g;
		chop($name);
	        for ($i=0; $i<($max-$min)/2; $i++)
		{
		    $nb = $min+2*$i;
		    print OUTPUT "\\begin{center}\n";
		    print OUTPUT "\\epsfig{file=./$name$nb.eps, height=6cm, width=6cm}\n";
		    $nb++;
		    print OUTPUT "\\epsfig{file=./$name$nb.eps, height=6cm, width=6cm}\n";
		    print OUTPUT "\\end{center}\n";
		}
		if ((int(($max-$min+1)/2)*2) < ($max-$min+1))
		{
		    print OUTPUT "\\begin{center}\n";
		    print OUTPUT "\\epsfig{file=./$name$max.eps, height=6cm, width=6cm}\n";
		    print OUTPUT "\\end{center}\n";
		}
	    }
	}
    }

    print OUTPUT $ligne;
}
close TEMPLATE;
close OUTPUT;




system(@plot_cmd);

opendir THISDIR, $eps or die "Can not find eps dir";
@allfiles = readdir THISDIR;
closedir THISDIR;

foreach $i (@allfiles)
{
system("cp", "eps/$i", "tmp");
}
chdir "tmp";
system(@latex_cmd);
system(@dvi_cmd);
system(@pdf_cmd);
system(@mv_cmd);
