/*********************************************************/
/* This file is part of strs a statistical test suite    */
/*              of random sequences.                     */
/*             David Lubicz CELAR                        */
/*            Copyright (C) 2006 David Lubicz            */
/*********************************************************/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/***************************************************************/
/* This library contain the definition of special fonctions    */
/*  is alea testing                                            */
/***************************************************************/
#include <math.h>
extern double igam ( double, double );

/* incomplete gamma integral */
double chi2_distribution(double x, void *n)

{
  int *i;
  double y,z;
  double result;
  
  i = (int *)n;
  y = (double)x/2.0;
  z = (double)(*i)/2.0;
  result = igam((double)z,(double)y);
  return result;
}


/* normal bell curve distribution function           */
double normal(double x, void *n)
{
  double arg, result, sqrt2=1.414213562373095048801688724209698078569672;

  if (x > 0) {
    arg = x/sqrt2;
    result = 0.5 * ( 1 + erf(arg) );
  }
  else {
    arg = -x/sqrt2;
    result = 0.5 * ( 1 - erf(arg) );
  }
  return(result);
}

double normal2(double a)
{ return (1.0-0.5*erfc(a/sqrt(2.0))); }

