/*********************************************************/
/* This file is part of strs a statistical test suite    */
/*              of random sequences.                     */
/*             David Lubicz CELAR                        */
/*            Copyright (C) 2006 David Lubicz            */
/*********************************************************/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "../include/bitutils.h"
#include "../include/test.h"

#define MAX_LIN 1000
#define NB_CHUNKS 100

/**********************************
 *   MAIN                         *
 **********************************/
main(int argc, char *argv[])

{
  int i;
  struct BitField bits;
  struct test_parameters parameters;
  struct test result;
  struct statistic ret;

  if (argc > 0)
    {
      if (BF_Open_File(&bits, argv[1]))
	{
	  parameters.nb_chunks = NB_CHUNKS;
	  parameters.data = &bits;

	  result = Statistic_Linear_Complexity(parameters);
	  printf("Mean linear complexity : %f \n", result.z);
	  printf("Min linear complexity : %f \n", result.min);
	  printf("Max linear complexity : %f \n", result.max);
 

/* 	  ret = Linear_Complexity_Chi2(&bits, 200, 10); */

	  printf("result: %f \n", ret.z);
	  BF_Dispose(&bits);
	}
      else
	{
	  printf("Can not open file %s \n",argv[1]);
	}
    }
  else
    {
      printf("Usage: test name_of_file \n");
      exit(1);
    }
}
