/*********************************************************/
/* This file is part of strs a statistical test suite    */
/*              of random sequences.                     */
/*             David Lubicz CELAR                        */
/*            Copyright (C) 2006 David Lubicz            */
/*********************************************************/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/***************************************************************/
/* This library contains a set of type to perform all the      */
/* bit manipulations currently used in alea testing and block  */
/* cypher simulation                                           */
/***************************************************************/
#ifndef __BTYPES_H_
#define __BTYPES_H_

#include "config.h"

#define MAX(x,y)             ((x) <  (y)  ? (y)  : (x))
#define MIN(x,y)             ((x) >  (y)  ? (y)  : (x))
#define REMAINDER(x,y)       (x ^ ((x >> y ) << y ))
#define BITLENGTH(x)         (((x->l - 1) << (LOG2WORDLENGTH)) + x->offset+1)
#define BYTELENGTH(x)        ((x->l - 1) << LOG2WORDLENGTH >> 3UL) + ((x->offset + 1)>> 3UL)
#define RGETBIT(x, offset)   (x << offset >> offset)
#define LGETBIT(x, offset)   (x >> offset << offset)
#define RSETBIT(x, offset, bit)   ((x << (WORDLENGTH - offset) >> (WORDLENGTH - offset)) | (bit << offset))        

#ifdef ARCH32 
typedef unsigned long int word_t;
typedef unsigned long int bsize_t;
typedef int boffset_t;
#endif

#ifdef ARCH64
typedef unsigned long long int word_t;
typedef unsigned long long int bsize_t;
typedef int boffset_t;
#endif


struct BitField {
  bsize_t l; /* lenght of the Bit Field in word*/
  bsize_t mem; /* amount of memory allocated for the Bit Field */
  word_t *data; /* pointeur to the array of int containing the bits */
  boffset_t offset; /* number of bits in the last int  so that the total number of bits in data in l*sizeof(int)>+offset+1 */
};

#endif /*__BTYPES_H_ */
