/*********************************************************/
/* This file is part of strs a statistical test suite    */
/*              of random sequences.                     */
/*             David Lubicz CELAR                        */
/*            Copyright (C) 2006 David Lubicz            */
/*********************************************************/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* function to compute the scalar product of two BitFields */
word_t BF_Scalar(struct BitField *Field1, struct BitField *Field2, bsize_t l)
{
  bsize_t wordl;
  boffset_t offset;
  struct BitField Field3, Field4;
  word_t retenue;
  
  if ((l > BITLENGTH(Field1)) || (l > BITLENGTH(Field2)))
    {
      return -1;
    }
  else
    {
      BF_Create(&Field3,l,l); BF_Create(&Field4,l,l);
      BF_And(Field1, Field2, &Field3, l);
      
      wordl = l >> LOG2WORDLENGTH;
      offset = l ^ wordl;
      if (offset > 0)
	retenue = wordscalar((&Field3)->data[wordl+1] << (WORDLENGTH - offset), 0xFFFFFFFF);
      else
	retenue = 0;
      
      while (wordl >1UL)
	{
	  wordl = wordl >>1UL;
	  if ((&Field3)->l & 1UL)
	    retenue = retenue & wordscalar((&Field3)->data[l], 0xFFFFFFFF);
	  (&Field4)->l = wordl;
	  (&Field4)->offset = 0;
	  (&Field4)->data = Field1->data + (l << LOG2WORDLENGTH);
	  BF_And(&Field3, &Field4, &Field3, wordl << LOG2WORDLENGTH);
	}
      retenue = retenue & wordscalar((&Field3)->data[0], 0xFFFFFFFF);
    }
  BF_Dispose(&Field3); BF_Dispose(&Field4);

  return retenue;
}
